/* TEM prefix is an acronym for TextEdit Macro. These macros
   call either TextEdit routines if the text record contains
   a TextEdit record, or TE32K routines if the text record
   contains a TE32K record. This results in klutzy "poor-man's"
   OOP. */

#define TEH				((TEHandle) (**(text)).te)
#define TEH32K				((TE32KHandle) (**(text)).te)
#define ISEDIT				TxIsEdit(text)

#define TEMActive(text)			( ISEDIT ? TEActive(TEH) : TE32KActive(TEH32K))
#define TEMGetOffset(text, lpt)		( ISEDIT ? TEGetOffset(LPointToPoint(lpt), TEH) : TE32KDoGetOffset((lpt), TEH32K))
#define TEMHeight(text, start, end)	( ISEDIT ? TEGetHeight((start), (end), TEH) : TE32KGetHeight((start), (end), TEH32K))
#define TEMJust(text)			( ISEDIT ? TEJust(TEH) : teJustLeft)
#define TEMLength(text)			( ISEDIT ? TELength(TEH) : TE32KLength(TEH32K))
#define TEMLineEnd(text, line)		( ISEDIT ? TELineEnd((line), TEH) : TE32KLineEnd((line), TEH32K))
#define TEMLines(text)			( ISEDIT ? TELines(TEH) : TE32KLines(TEH32K))
#define TEMLineStart(text, line)	( ISEDIT ? TELineStart((line), TEH) : TE32KLineStart((line), TEH32K))
#define TEMMaxLength(text)		( ISEDIT ? TE_MAX_LENGTH : TE32K_MAX_LENGTH)
#define TEMMaxLines(text)		( ISEDIT ? TE_MAX_LINES : TE32K_MAX_LINES)
#define TEMPort(text)			( ISEDIT ? TEPort(TEH) : TE32KPort(TEH32K))
#define TEMSelEnd(text)			( ISEDIT ? TESelEnd(TEH) : TE32KSelEnd(TEH32K))
#define TEMSelStart(text)		( ISEDIT ? TESelStart(TEH) : TE32KSelStart(TEH32K))
#define TEMStyleScrap(text)		( ISEDIT ? TEStyleScrap(TEH) : TE32KStyleScrap(TEH32K))
#define TEMText(text)			( ISEDIT ? TEText(TEH) : TE32KText(TEH32K))
#define TEMWrap(text)			( ISEDIT ? TEWrap(TEH) : TE32KWrap(TEH32K))
#define TEMWidth(text, start, end, timeout, last) \
					( ISEDIT ? TEWidthTimeout((start), (end), (timeout), (last), TEH) : TX_MAX_MARGIN)

#define TEMActivate(text, active)	{ if (ISEDIT) TEDoActivate((active), TEH); else TE32KDoActivate((active), TEH32K); }
#define TEMCalText(text)		{ if (ISEDIT) TECalText(TEH); else TE32KCalText(TEH32K); }
#define TEMClick(text, pt, extend)	{ if (ISEDIT) TEClick((pt), (extend), TEH); else TE32KClick((pt), (extend), TEH32K); }
#define TEMClickLoopSet(text, loop)	{ if (ISEDIT) SetClikLoop((loop), TEH); else TE32KClickLoopSet((loop), TEH32K); }
#define TEMCopy(text)			{ if (ISEDIT) TEDoCopy(TEH); else TE32KDoCopy(TEH32K); }
#define TEMDelete(text)			{ if (ISEDIT) TEDelete(TEH); else TE32KDelete(TEH32K); }
#define TEMDest(text, dest)		{ if (ISEDIT) TEDest((dest), TEH); else TE32KDest((dest), TEH32K); }
#define TEMDestSet(text, dest)		{ if (ISEDIT) TEDestSet((dest), TEH); else TE32KDestSet((dest), TEH32K); }
#define TEMDispose(text)		{ if (ISEDIT) TEDispose(TEH); else TE32KDispose(TEH32K); }
#define TEMGetPoint(text, offset, lpt)	{ if (ISEDIT) LPointFromPoint((lpt), TEGetPoint((offset), TEH)); else TE32KDoGetPoint((offset), (lpt), TEH32K); }
#define TEMIdle(text)			{ if (ISEDIT) TEIdle(TEH); else TE32KIdle(TEH32K); }
#define TEMInsert(text, p, n, style)	{ if (ISEDIT) TEDoInsert((p), (n), (style), TEH); else TE32KInsert((Ptr) (p), (n), TEH32K); }
#define TEMJustSet(text, just)		{ if (ISEDIT) TESetJust((just), TEH); }
#define TEMKey(text, key)		{ if (ISEDIT) TEKey((key), TEH); else TE32KKey((key), TEH32K); }
#define TEMPaste(text)			{ if (ISEDIT) TEDoPaste(TEH); else TE32KDoPaste(TEH32K); }
#define TEMPortSet(text, port)		{ if (ISEDIT) TEPortSet((port), TEH); else TE32KPortSet((port), TEH32K); }
#define TEMReplaceText(text, h)		{ if (ISEDIT) TEReplaceText((h), TEH); else TE32KReplaceText((h), TEH32K); }
#define TEMScroll(text, dh, dv)		{ if (ISEDIT) TEScroll((dh), (dv), TEH); else TE32KScroll((dh), (dv), TEH32K); }
#define TEMSelect(text, start, end)	{ if (ISEDIT) TESetSelect((start), (end), TEH); else TE32KSetSelect(start, end, TEH32K); }
#define TEMSelEndSet(text, end)		{ if (ISEDIT) TESelEndSet((end), TEH); else TE32KSelEndSet(end, TEH32K); }
#define TEMSelStartSet(text, start)	{ if (ISEDIT) TESelStartSet((start), TEH); else TE32KSelStartSet(start, TEH32K); }
#define TEMSetText(text, p, n)		{ if (ISEDIT) TEDoSetText(p, n, TEH); else TE32KSetText((Ptr) p, n, TEH32K); }
#define TEMStyle(text, style, height, ascent)	{ if (ISEDIT) TEStyle(style, height, ascent, TEH); else TE32KStyle(style, height, ascent, TEH32K); }
#define TEMStyleContinuous(text, mode, style)	{ if (ISEDIT) TEStyleContinuous(mode, style, TEH); else TE32KStyleContinuous(mode, style, TEH32K); }
#define TEMStyleOffset(text, offset, style, height, ascent)	{ if (ISEDIT) TEStyleOffset(offset, style, height, ascent, TEH); else TE32KStyle(style, height, ascent, TEH32K); }
#define TEMStyleScrapSet(text, styles, redraw)	{ if (ISEDIT) TEStyleScrapSet(styles, redraw, TEH); else TE32KStyleScrapSet(styles, redraw, TEH32K); }
#define TEMStyleSet(text, mode, style, redraw)	{ if (ISEDIT) TEStyleSet(mode, style, redraw, TEH); else TE32KStyleSet(mode, style, redraw, TEH32K); }
#define TEMUpdate(text, view)		{ if (ISEDIT) TEUpdate(view, TEH); else TE32KDoUpdate(view, TEH32K);  }
#define TEMView(text, view)		{ if (ISEDIT) TEView(view, TEH); else TE32KView(view, TEH32K); }
#define TEMViewSet(text, view)		{ if (ISEDIT) TEViewSet(view, TEH); else TE32KViewSet(view, TEH32K); }
#define TEMWrapSet(text, wrap)		{ if (ISEDIT) TEWrapSet((wrap), TEH); else TE32KWrapSet((wrap), TEH32K); }
